% this file performs test of independence of bids across bidder-groups
% (dealers and customers)

global aucgroupsize model pgrid pstep resamplingdraws bidstepscum bidsteps estim bootdraws Group1 Group2 Group3 nbidfun invbidboot boc_bids matur oversample supplynoise

%this test is based on BIDS, therefore substitute here any files with
%results from 3m or 12m auctions (depending on which you want to test) as 
% these files are used only to "fill" the global variables defined above

%load('/home/jakub/Matlab/Ali_Testing/Results/1-auction/canada_model_M1_3m_ag_116_O1_S0.1.mat')
load('/home/jakub/Matlab/Ali_Testing/Results/1-auction/canada_model_M1_12m_ag_116_O1_S0.1.mat')

%number of bootstrap draws for "direct" CDF testing
bootdraws_CDF=100;

for auctiongroup=1:floor(116/aucgroupsize)
     [estim,noncomp,bidsteps,bidstepscum,pgrid,invbidfunc,span,spannonc,updated,infoset,relevinvbid]=dataread(auctiongroup,pstep);
     firstbids_all{auctiongroup,1}=estim(1,5);
     q_wgh_bid_all{auctiongroup,1}=estim(1:bidstepscum(1,1),5)'*estim(1:bidstepscum(1,1),7)/sum(estim(1:bidstepscum(1,1),7));
     if any(Group1==estim(1,4))
         firstbids_d{auctiongroup,1}=estim(1,5);
         q_wgh_bid_d{auctiongroup,1}=estim(1:bidstepscum(1,1),5)'*estim(1:bidstepscum(1,1),7)/sum(estim(1:bidstepscum(1,1),7));
         firstbids_c{auctiongroup,1}=[];
         q_wgh_bid_c{auctiongroup,1}=[];
     else
         firstbids_c{auctiongroup,1}=estim(1,5);
         q_wgh_bid_c{auctiongroup,1}=estim(1:bidstepscum(1,1),5)'*estim(1:bidstepscum(1,1),7)/sum(estim(1:bidstepscum(1,1),7));
         firstbids_d{auctiongroup,1}=[];
         q_wgh_bid_d{auctiongroup,1}=[];
     end
     
     firstbids{auctiongroup,1}=[];
     q_wgh_bid{auctiongroup,1}=[];
     for bidder=2:size(bidsteps,1)
         firstbids{auctiongroup,1}= [firstbids{auctiongroup,1} ; estim(bidstepscum(bidder-1,1)+1,5)];
         q_wgh_bid{auctiongroup,1}=[q_wgh_bid{auctiongroup,1} ; estim(bidstepscum(bidder-1,1)+1:bidstepscum(bidder,1),5)'*estim(bidstepscum(bidder-1,1)+1:bidstepscum(bidder,1),7)/sum(estim(bidstepscum(bidder-1,1)+1:bidstepscum(bidder,1),7))];
         if any(Group1==estim(bidstepscum(bidder,1),4))
             firstbids_d{auctiongroup,1}= [firstbids_d{auctiongroup,1} ; estim(bidstepscum(bidder-1,1)+1,5)];
             q_wgh_bid_d{auctiongroup,1}=[q_wgh_bid_d{auctiongroup,1} ; estim(bidstepscum(bidder-1,1)+1:bidstepscum(bidder,1),5)'*estim(bidstepscum(bidder-1,1)+1:bidstepscum(bidder,1),7)/sum(estim(bidstepscum(bidder-1,1)+1:bidstepscum(bidder,1),7))];
         else
             firstbids_c{auctiongroup,1}= [firstbids_c{auctiongroup,1} ; estim(bidstepscum(bidder-1,1)+1,5)];
             q_wgh_bid_c{auctiongroup,1}=[q_wgh_bid_c{auctiongroup,1} ; estim(bidstepscum(bidder-1,1)+1:bidstepscum(bidder,1),5)'*estim(bidstepscum(bidder-1,1)+1:bidstepscum(bidder,1),7)/sum(estim(bidstepscum(bidder-1,1)+1:bidstepscum(bidder,1),7))];
         end                     
     end   
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% First Wilcoxon rank sum test of identical distributions:  %%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% does not work across auctions for dealers, works fairly ok for customers:
% something shifts levels across auctions probably
for i=1:20
    for j=1:20
        if i<j
             results_test_q_wgh_d(i,j)=ranksum(q_wgh_bid_d{i,1},q_wgh_bid_d{j,1});
             results_test_first_d(i,j)=ranksum(firstbids_d{i,1},firstbids_d{j,1});
             results_test_q_wgh_c(i,j)=ranksum(q_wgh_bid_c{i,1},q_wgh_bid_c{j,1});
             results_test_first_c(i,j)=ranksum(firstbids_c{i,1},firstbids_c{j,1});
%             ranksum(firstbids_c{1,1},firstbids_c{5,1})
        end
    end
end

% within auctions:
for i=1:116    
             [within_results_test_q_wgh_d(i,1),within_results_test_q_wgh_d(i,2)]=ranksum(q_wgh_bid_d{i,1}(1:ceil(size(q_wgh_bid_d{i,1},1)/2),1),q_wgh_bid_d{i,1}(ceil(size(q_wgh_bid_d{i,1},1)/2)+1:end,1));
             [within_results_test_first_d(i,1),within_results_test_first_d(i,2)]=ranksum(firstbids_d{i,1}(1:ceil(size(firstbids_d{i,1},1)/2),1),firstbids_d{i,1}(ceil(size(firstbids_d{i,1},1)/2)+1:end,1));
             %results_test_q_wgh_c(i,j)=ranksum(q_wgh_bid_c{i,1}(1:ceil(size(q_wgh_bid_d{i,1},1)/2),1),q_wgh_bid_c{i,1});
             %results_test_first_c(i,j)=ranksum(firstbids_c{i,1},firstbids_c{i,1});
end
disp(['Within auction q-wgt reject: ' num2str(sum(within_results_test_q_wgh_d(:,2)))])
disp(['Within auction 1st bid reject: ' num2str(sum(within_results_test_first_d(:,2)))])

% across a pair of successive auctions splitting sample (half from auc t,
% half from auc t+1 in sample 1, and second halves in sample 2)
for i=1:115    
             [across_results_test_q_wgh_d(i,1),across_results_test_q_wgh_d(i,2)]=ranksum([q_wgh_bid_d{i,1}(1:ceil(size(q_wgh_bid_d{i,1},1)/2),1); ...
                 q_wgh_bid_d{i+1,1}(1:ceil(size(q_wgh_bid_d{i+1,1},1)/2),1)],[q_wgh_bid_d{i,1}(ceil(size(q_wgh_bid_d{i,1},1)/2)+1:end,1) ; q_wgh_bid_d{i+1,1}(ceil(size(q_wgh_bid_d{i+1,1},1)/2)+1:end,1)]);
             [across_results_test_first_d(i,1),across_results_test_first_d(i,2)]=ranksum([firstbids_d{i,1}(1:ceil(size(firstbids_d{i,1},1)/2),1); ...
                 firstbids_d{i+1,1}(1:ceil(size(firstbids_d{i+1,1},1)/2),1)],[firstbids_d{i,1}(ceil(size(firstbids_d{i,1},1)/2)+1:end,1); firstbids_d{i+1,1}(ceil(size(firstbids_d{i+1,1},1)/2)+1:end,1)]);
             %results_test_q_wgh_c(i,j)=ranksum(q_wgh_bid_c{i,1}(1:ceil(size(q_wgh_bid_d{i,1},1)/2),1),q_wgh_bid_c{i,1});
             %results_test_first_c(i,j)=ranksum(firstbids_c{i,1},firstbids_c{i,1});
end
disp(['across 2 auctions q-wgt reject: ' num2str(sum(across_results_test_q_wgh_d(:,2)))])
disp(['across 2 auctions 1st bid reject: ' num2str(sum(across_results_test_first_d(:,2)))])

% across a three successive auctions splitting sample (half from auc t,
% half from auc t+1 in sample 1, and second halves in sample 2)
for i=1:114    
             [across_results_test_q_wgh_d(i,1),across_results_test_q_wgh_d(i,2)]=ranksum([q_wgh_bid_d{i,1}(1:ceil(size(q_wgh_bid_d{i,1},1)/2),1); ...
                 q_wgh_bid_d{i+1,1}(1:ceil(size(q_wgh_bid_d{i+1,1},1)/2),1); ...
                 q_wgh_bid_d{i+2,1}(1:ceil(size(q_wgh_bid_d{i+2,1},1)/2),1)],[q_wgh_bid_d{i,1}(ceil(size(q_wgh_bid_d{i,1},1)/2)+1:end,1) ; ...
                 q_wgh_bid_d{i+1,1}(ceil(size(q_wgh_bid_d{i+1,1},1)/2)+1:end,1); ...
                 q_wgh_bid_d{i+2,1}(ceil(size(q_wgh_bid_d{i+2,1},1)/2)+1:end,1)]);
             [across_results_test_first_d(i,1),across_results_test_first_d(i,2)]=ranksum([firstbids_d{i,1}(1:ceil(size(firstbids_d{i,1},1)/2),1); ...
                 firstbids_d{i+1,1}(1:ceil(size(firstbids_d{i+1,1},1)/2),1); ...
                 firstbids_d{i+2,1}(1:ceil(size(firstbids_d{i+2,1},1)/2),1)],[firstbids_d{i,1}(ceil(size(firstbids_d{i,1},1)/2)+1:end,1); ...
                 firstbids_d{i+1,1}(ceil(size(firstbids_d{i+1,1},1)/2)+1:end,1); ...
                 firstbids_d{i+2,1}(ceil(size(firstbids_d{i+2,1},1)/2)+1:end,1)]);
             %results_test_q_wgh_c(i,j)=ranksum(q_wgh_bid_c{i,1}(1:ceil(size(q_wgh_bid_d{i,1},1)/2),1),q_wgh_bid_c{i,1});
             %results_test_first_c(i,j)=ranksum(firstbids_c{i,1},firstbids_c{i,1});
end
disp(['across 3 auctions q-wgt reject: ' num2str(sum(across_results_test_q_wgh_d(:,2)))])
disp(['across 3 auctions 1st bid reject: ' num2str(sum(across_results_test_first_d(:,2)))])



