% This file constructs the tests for independence of q-weighted bids.

%biddat = dlmread('3m_qw_bids.csv',',');
biddat = dlmread('12m_qw_bids.csv',',');


aucind = unique(biddat(:,1));





stats = [];

for perm = 1:100
    
corr_pearson = []; 
corr_kendall = []; 
corr_spearman = [];     
reject_bkr = [];
for t = 1:length(aucind)
       indt = find(biddat(:,1)==aucind(t));
       bidt = biddat(indt,2);
       % generate a random permutation of the bids
       bidorder = randperm(length(bidt));
       bidt_r=bidt(bidorder);
       
       x = bidt_r(1:floor(length(bidt_r)/2));
       y = bidt_r(floor(length(bidt_r)/2)+1:2*floor(length(bidt_r)/2));
    
       [rho,pval] = corr(x,y,'type','Spearman');       
       corr_spearman = [corr_spearman; [t,rho,pval]];
       [rho,pval] = corr(x,y,'type','Pearson');       
       corr_pearson = [corr_pearson; [t,rho,pval]];
       [rho,pval] = corr(x,y,'type','Kendall');       
       corr_kendall = [corr_kendall; [t,rho,pval]];     
       
       % B-K-R test with 5% critical value
       [nBn, reject] = bkr(x,y,0.05);
       reject_bkr = [reject_bkr; [t,nBn, reject]];
       
end


%['no of auctions with significant (0.05) Pearson correlation in bids']

%['no of auctions with significant (0.05) Spearman correlation in bids']

%['no of auctions with significant (0.05) Kendall correlation in bids']


stats = [stats; [perm,sum((corr_pearson(:,3)<=0.05)),sum((corr_spearman(:,3)<=0.05)),sum((corr_kendall(:,3)<=0.05)), sum((reject_bkr(:,3)==1))]];
end
