%Testing for public information causing updating
%Running this code results in two variables:
% (1) 'same_auc_sort' : 1st col. auction ID, 2nd: submitter of updated bid,
% 3rd: time to deadline
% (2)  'difftime': 1st col: auction ID, 2nd: Mimimum time difference
% between two updated bids by different submitters


%read all at once - this is for getting summary statistics mainly, not for actual estimation
[estim_all,noncomp_all,bidsteps_all,bidstepscum_all,pgrid_all,invbidfunc_all,span,spannonc,Group1,Group2,updated_all,infoset_all,relevinvbid_all]=dataread(0,pstep);
nbidfun=size(invbidfunc_all);

% 8th column of estim_all has time to deadline and updated has in 3rd and
% 4th columns the addresses of beginning and end of an update bid in estim

% Search if updated bids in the same auction:
upd_in_auc=0;
j=0;
temp=1;
for i=2:size(updated_all,1)
    if updated_all(i,1)==updated_all(i-1,1)
        upd_in_auc=upd_in_auc+1;
        if j==0
            same_auc(temp,:)=[updated_all(i-1,1:2) estim_all(updated_all(i-1,3),8)];
            temp=temp+1;
        end
        %Record [auction submitter time_to_deadline(of the updated bid)]
        same_auc(temp,:)=[updated_all(i,1:2) estim_all(updated_all(i,3),8)];
        temp=temp+1;
        j=1;
    else
        j=0;
    end
end

%Unconditional histogram of updating times (the right way is conditional on
%an auction, but too few updates in any auction)
hist(same_auc(:,3))

%Let's find the minimal difference between two updates of two different
%bidders in each auction
temp=1;
same_auc_sort=sortrows(same_auc,[1 -3]); %Sort by auction and time to deadline
difftime=[0 0];
for i=2:size(same_auc_sort,1)
    if same_auc_sort(i,1)==same_auc_sort(i-1,1) %Same auction
        if difftime(temp,1)==same_auc_sort(i,1) %Already a time record for this auction
            %Record only if difftime smaller & different bidder
            if difftime(temp,2)>same_auc_sort(i-1,3)-same_auc_sort(i,3) && same_auc_sort(i,2)~=same_auc_sort(i-1,2)
                difftime(temp,2)=same_auc_sort(i-1,3)-same_auc_sort(i,3); 
            end
        else
            if same_auc_sort(i,2)~=same_auc_sort(i-1,2) %Different submitter
                temp=temp+1;
                difftime(temp,:)=[same_auc_sort(i,1) same_auc_sort(i-1,3)-same_auc_sort(i,3)];
            end
        end
    else
%        temp=temp+1;
        
    end
            
end
difftime=difftime(2:end,:); %Drop the auxiliary line

save('public_info.mat','same_auc_sort','difftime')
clear
load public_info.mat
