function [clearprice]=actualressup(bidder,noncomp)

global pgrid bidstepscum estim invbidboot

% Construct actual residual supply corresponding to an auction in which
% 'bidder' participates. If bidder's bid in 'invbidboot' is not his
% actual last bid submitted in this auction, his last bid is substituted
%to get a hypothetical mkt clearing price if he did not change his bid

actbidind=find(estim(bidstepscum(bidder,1),2)==estim(:,2));
actnon=noncomp(estim(bidstepscum(bidder,1),2)==noncomp(:,2),:);

%Now find relevant invbidfunctions (go through estim and pick last bids of
%submitters
clear a2 a3
%Find last step of the bid closest to the deadline
    a2=actbidind(find(estim(actbidind(1:end-1),4)~=estim(actbidind(2:end),4))); %indices in actbidind of last steps of different bidder
    a3=actbidind(find(estim(actbidind(1:end-1),8)~=estim(actbidind(2:end),8))); %indices where new submission is next   
    a2(end+1,1)=actbidind(end,1); %add last bidder in this auction
    a3(end+1,1)=actbidind(end,1); %add last bidder in this auction
    a3=union(a2,a3); %just to make sure if we had different bidders with same submission times
clear a4
a4= [ ];    
for i=1:size(a3,1)   
    %Pick index with lowest submission time for each bidder only
    %as long as it is positive!, but make
    %sure it is the dealer (customers may route bids through multiple
    %guys!)
    %1st condition: same dealer, 2nd: same submitter, 3rd: min time
    a4(end+1,1)=a3(find(estim(a3(i,1),1)==estim(a3,1) &...
        estim(a3(i,1),4)==estim(a3,4) & ...
        estim(a3,8)==min(estim(a3(find(estim(a3(i,1),1)==estim(a3,1) & ...
        estim(a3(i,1),4)==estim(a3,4) & ...
        estim(a3(i,1),1)==estim(a3,1) ),1),8))),1);        
end
a4=unique(a4);

%Find indices of inverse demands to add up:
bidindices = [ ];
for i=1:size(a4,1)
    bidindices(end+1,1)=find(bidstepscum==a4(i,1));
end

%Replace one bid if 'bidder's bid not the actual last bid of his in the
%auction
if any(bidindices==bidder)
    temp=find(estim(bidstepscum(bidder,1),4)==estim(a3,4)); %finds all indices of this bidder
    bidindices(find(bidindices==max(temp)),1)=bidder; %replace the maximum (last bid)
end
    
    
actualressup=sum(invbidboot(bidindices,:));
actualressup=actualressup-sum(actnon(:,9)); % subtract non-competitive bids

clearprice=pgrid(1,find(actualressup>1,1,'last')); %figure out the clearing price