function [test,samplestat,critval]=cvtest_compute(teststat,level)
%%%%Delivers a vector 'testQ' of "samplestatQ-critvalQ" - each line corresponds to a
%%%%bidder-step (with same quantity request)

bootdraws=size(teststat,2);

%%%%Construct a critical value for each updating bidder:
if nargin==1
    level=0.05;
end
if size(teststat{1,1},2)>1
    for i=1:bootdraws
        temp{1,i}=teststat{1,i}(:,3);
    end
    teststat=temp;
end

bidders=size(teststat{1,1},1)-1; %1st line in each cell is auxiliary
critval=zeros(bidders,1);
stat=zeros(bidders,bootdraws-1);
for i=2:bootdraws %First cell is the test statistic on the observed sample
    stat(:,i-1)=teststat{1,i}(2:end,1);    
end   
ordstat=(sort(stat'))';
cutoff=max(floor((1-level)*size(ordstat,2)),1);
cutoff2=ceil((1-level)*size(ordstat,2));
%ADJUST!!!
%critval=norminv(1-level/2,0,1)*std(ordstat);
samplestat=teststat{1,1}(2:end,1);    
critval=ordstat(:,cutoff)-samplestat; %re-center critical values
critvalup=ordstat(:,cutoff2)-samplestat;

test=samplestat-critval; %Positive entries of this vector lead to rejection of private value for that bidder
testup=samplestat-critvalup;

