function[exputmin,exputmax,util]=exputil_da(bidder,margval,psort,bidsteps,bidstepscum,estim)

global auctionminprice yield

%This function computes the expected utility from a DA of a 'bidder' with values
%'margval' and distribution of market clearing prices being 'psort' and his
%actual bid being in estim.

%Now let's get expected utility: using his bidfunction, distribution of market
%clearing price and estimated values for those quantities, we can obtain
%this

if exist('yield','var')==0
    if estim(1,5)<100 %prices are in interest rates
        yield=1;
    else
        yield=0;
    end
end

%First cut nonclearing cases (zero prices or huge adjustments by gov't
%(i.e., strange draws of resid supply))
draws=size(psort);
step=1;
bad=0;
adjust=0;
exputmin=0;
exputmax=0;
util=0;
for i=1:draws(1,1)
    if psort(i,1)==0
        bad=bad+1;
    end
    %round prices to 3 decimal digits if in yields:
    if yield==1
        psort(i,1)=round(psort(i,1)*1000)/1000;
    end
    if psort(i,1)==auctionminprice
        adjust=adjust+1;
    end
end
puseful=psort(bad+1:draws(1,1),:);

n=size(puseful);
margsize=size(margval);
estsize=size(estim);
margval(1,margsize(1,2)+1)=0;

%Let's go from the highest price to evaluate how much the bidder gets
%The only problem is if the market clearing price equals his bid, since in
%that case he will be rationed.

i=n(1,1);
while i>=1
    adj_i=1;
    grosutmin=0;
    grosutmax=0;
    pay=0;   
    if bidder==1
        if bidsteps(bidder)>step, lowerp=estim(step+1,5); else lowerp=0; end %this will denote the price of next step
        if puseful(i,1)<=estim(step,5) && puseful(i,1)>lowerp
            if puseful(i,1)<estim(step,5) %no rationing
                %First step:
                grosutmin=margval(1,1)*estim(1,7);
                grosutmax=margval(1,1)*estim(1,7);
                pay=estim(1,5)*estim(1,7);
                if step>1
                    for j=2:step
                            grosutmax=grosutmax+margval(1,j-1)*(estim(j,7)-estim(j-1,7)); %sums up gross utility
                            grosutmin=grosutmin+margval(1,j)*(estim(j,7)-estim(j-1,7));
                            pay=pay+estim(j,5)*(estim(j,7)-estim(j-1,7));
                    end
                end
            else %rationing
                if step>1 %no rationing at first step
                    grosutmin=margval(1,1)*estim(1,7);
                    grosutmax=margval(1,1)*estim(1,7);
                    pay=estim(1,5)*estim(1,7);
                    for j=2:step-1
                            grosutmax=grosutmax+margval(1,j-1)*(estim(j,7)-estim(j-1,7)); %sums up gross utility
                            grosutmin=grosutmin+margval(1,j)*(estim(j,7)-estim(j-1,7));
                            pay=pay+estim(j,5)*(estim(j,7)-estim(j-1,7));
                    end
                    %figure out quantity after rationing at 'step':
                    grosutmax=grosutmax+margval(1,step-1)*(estim(step,7)-estim(step-1,7))*puseful(i,6);
                    grosutmin=grosutmin+margval(1,step)*(estim(step,7)-estim(step-1,7))*puseful(i,6);
                    pay=pay+estim(step,5)*(estim(step,7)-estim(step-1,7))*puseful(i,6);                    
                else %rationing at first step.     puseful(i,6) is the rat coeff in resampled state i
                    grosutmin=margval(1,1)*estim(1,7)*puseful(i,6);
                    grosutmax=margval(1,1)*estim(1,7)*puseful(i,6); 
                    pay=estim(1,5)*estim(1,7)*puseful(i,6);
                end
            end
        else
            if puseful(i,1)<=lowerp
               step=step+1;                              
               adj_i=0; % do not move to next clearing price
            end
        end
    else
        if bidsteps(bidder)>step, lowerp=estim(min(bidstepscum(bidder-1,1)+step+1,estsize(1,1)),5); else lowerp=0; end %this will denote the price of next step
        if puseful(i,1)<=estim(bidstepscum(bidder-1,1)+step,5) && puseful(i,1)>lowerp 
            if puseful(i,1)<estim(bidstepscum(bidder-1,1)+step,5) %no rationing
                % First step:
                grosutmin=margval(1,1)*estim(bidstepscum(bidder-1,1)+1,7);
                grosutmax=margval(1,1)*estim(bidstepscum(bidder-1,1)+1,7);
                if margval(1,1)>0 %it's discriminatory auction! pay only bid on the marginal demand!!!
                    pay=estim(bidstepscum(bidder-1,1)+1,5)*estim(bidstepscum(bidder-1,1)+1,7);                   
                else
                     pay=0;                     
                end                    
                if step>1
                    for j=2:step
                        grosutmax=grosutmax+margval(1,j-1)*(estim(bidstepscum(bidder-1,1)+j,7)-estim(bidstepscum(bidder-1,1)+j-1,7));
                        grosutmin=grosutmin+margval(1,j)*(estim(bidstepscum(bidder-1,1)+j,7)-estim(bidstepscum(bidder-1,1)+j-1,7));
                        pay=pay+estim(bidstepscum(bidder-1,1)+j,5)*(estim(bidstepscum(bidder-1,1)+j,7)-estim(bidstepscum(bidder-1,1)+j-1,7));
                    end
                end
            else %rationing
                if step>1 %no rationing at first step
                    grosutmin=margval(1,1)*estim(bidstepscum(bidder-1,1)+1,7);
                    grosutmax=margval(1,1)*estim(bidstepscum(bidder-1,1)+1,7);
                    pay=estim(bidstepscum(bidder-1,1)+1,5)*estim(bidstepscum(bidder-1,1)+1,7);
                    for j=2:step-1
                            grosutmax=grosutmax+margval(1,j-1)*(estim(bidstepscum(bidder-1,1)+j,7)-estim(bidstepscum(bidder-1,1)+j-1,7)); %sums up gross utility
                            grosutmin=grosutmin+margval(1,j)*(estim(bidstepscum(bidder-1,1)+j,7)-estim(bidstepscum(bidder-1,1)+j-1,7));
                            pay=pay+estim(j,5)*(estim(bidstepscum(bidder-1,1)+j,7)-estim(bidstepscum(bidder-1,1)+j-1,7));
                    end
                    %figure out quantity after rationing at 'step':
                    grosutmax=grosutmax+margval(1,step-1)*(estim(bidstepscum(bidder-1,1)+step,7)-estim(bidstepscum(bidder-1,1)+step-1,7))*puseful(i,6);
                    grosutmin=grosutmin+margval(1,step)*(estim(bidstepscum(bidder-1,1)+step,7)-estim(bidstepscum(bidder-1,1)+step-1,7))*puseful(i,6);
                    pay=pay+estim(step,5)*(estim(bidstepscum(bidder-1,1)+step,7)-estim(bidstepscum(bidder-1,1)+step-1,7))*puseful(i,6);                    
                else %rationing at first step.     puseful(i,6) is the rat coeff in resampled state i
                    grosutmin=margval(1,1)*estim(bidstepscum(bidder-1,1)+1,7)*puseful(i,6);
                    grosutmax=margval(1,1)*estim(bidstepscum(bidder-1,1)+1,7)*puseful(i,6);  
                    pay=estim(bidstepscum(bidder-1,1)+1,5)*estim(bidstepscum(bidder-1,1)+1,7)*puseful(i,6);
                end
            end                
        else
                if puseful(i,1)<=lowerp
                        step=step+1;
                        adj_i=0; % do not move to next clearing price
                end
        end
        
    end
    exputmin=exputmin+(grosutmin-pay)/n(1,1);
    exputmax=exputmax+(grosutmax-pay)/n(1,1);
    util(i,1)=(grosutmin-pay);
    util(i,2)=(grosutmax-pay);
    if adj_i==1
        i=i-1;
    end
end
