function [uninformedbid,informedbid,uninformedbid2,informedbid2,uninformedbid3,informedbid3]=FPA_data2(draws)
%Parameters:
%draws=500; %Number of signals for each bidder
%rand('state',0) %Reset rnd number generator

%Data for example 1 (Affiliated Values): (3 bidders)

signals=rand(draws,2); %First column is the signals of bidder 1
%about whom we care. 2nd column signal of bidder 2, which info will
%be given to bidder 1. 

%First bids when everybody is uninformed:
uninformedbid=7*signals(:,1)/12;

%Informed bidding:
%1st column in 'informedbid' is the bid, 2nd column is 1 if the bid was a corner
%solution or zero. Estimation of values should be done off bids when second column
%is not equal to to 1
% for i=1:draws
%     if signals(i,1)>=22*signals(i,2)/15
%         informedbid(i,1)=5*signals(i,1)/16+signals(i,2)/8;
%         informedbid(i,2)=0;
%     else
%         if signals(i,1)<22*signals(i,2)/15 && signals(i,1)>=5*signals(i,2)/12
%             informedbid(i,1)=7*signals(i,2)/12;
%             informedbid(i,2)=1;
%         else
%             informedbid(i,1)=0;
%             informedbid(i,2)=1;
%         end
%     end
% end
for i=1:draws
    if signals(i,1)>=4*signals(i,2)/3
        informedbid(i,1)=7*signals(i,1)/22+7*signals(i,2)/44;
        informedbid(i,2)=0;
    else
        if signals(i,1)<4*signals(i,2)/3 && signals(i,1)>=25*signals(i,2)/48
            informedbid(i,1)=7*signals(i,2)/12;
            informedbid(i,2)=1;
        else
            informedbid(i,1)=0;
            informedbid(i,2)=1;
        end
    end
end

%Data for example 2 (Private Values):
signals2=rand(draws,2); 
%signals2(1:draws,1)=rand(draws,1); 
% for i=1:draws
%     signals2(i,2)=rand(1,1)*signals2(i,1);
% end

uninformedbid2=2*signals2(:,1)/3;   
for i=1:draws
    if signals2(i,1)/2>=2*signals2(i,2)/3
        informedbid2(i,1)=signals2(i,1)/2;
        informedbid2(i,2)=0;
    else
        if signals2(i,1)/2<2*signals2(i,2)/3 && signals2(i,1)>=2*signals(i,2)/3
            informedbid2(i,1)=2*signals2(i,2)/3;
            informedbid2(i,2)=1;
        else
            informedbid2(i,1)=0;
            informedbid2(i,2)=1;
        end
    end
end

%Data for example 3: (Pure Common Values)
%For \alpha=2
value3=sqrt(rand(draws,1).^(-1));
signals3=rand(draws,2).*repmat(value3,1,2);
for i=1:draws
    if signals3(i,1)>=1
        uninformedbid3(i,1)=5*signals3(i,1)*(2+signals3(i,1)^(-3))/12;
        uninformedbid3(i,2)=0;
    else %Corner: signal less than 1
        uninformedbid3(i,2)=0;
        uninformedbid3(i,2)=1;
    end
end

for i=1:draws
    if signals3(i,1)>=1 && signals3(i,1)>=signals3(i,2)
        informedbid3(i,1)=5*signals3(i,1)*(2+signals3(i,1)^(-3))/12;
        informedbid3(i,2)=0;
    else
        if signals3(i,2)>=1 && signals3(i,1)<signals3(i,2)
            informedbid3(i,1)=5*signals3(i,2)*(2+signals3(i,2)^(-3))/12;
            informedbid3(i,2)=0;
        else %Corner: both signals less than 1
            informedbid3(i,1)=0;
            informedbid3(i,2)=1;
        end
    end
end

